package net.ihe.gazelle.tempgen.inc.test;

import static org.junit.Assert.assertTrue;

import gnu.trove.map.hash.THashMap;
import java.util.Map;
import java.util.Set;

import org.junit.Before;
import org.junit.Test;

import net.ihe.gazelle.tempgen.inc.checker.IncCheckRuleDefinition;
import net.ihe.gazelle.tempmodel.org.decor.art.model.Decor;
import net.ihe.gazelle.tempmodel.org.decor.art.model.RuleDefinition;
import net.ihe.gazelle.tempmodel.org.decor.art.utils.DecorMarshaller;
import net.ihe.gazelle.tempmodel.org.decor.art.utils.RulesUtil;
import net.ihe.gazelle.tempmodel.org.decor.art.utils.TemplateDefinitionUtil;

/**
 * 
 * @author Abderrazek Boufahja
 *
 */
public class IncCheckRuleDefinitionTest extends IncCheckRuleDefinition {
	
	Decor decorTemplates = null;
	
	@Before
	public void setUp(){
		decorTemplates = DecorMarshaller.loadDecor("src/test/resources/inc/decor_rule.xml");
	}

	@Test
	public void testProcess() {
		RuleDefinition firstRD = TemplateDefinitionUtil.getFirstElement(RulesUtil.getTemplates(decorTemplates.getRules()).get(0));
		Map<String, Set<String>> mapIncludedTemplates = new THashMap<String, Set<String>>();
		assertTrue(mapIncludedTemplates.size()==0);
		this.process(firstRD, mapIncludedTemplates);
		assertTrue(mapIncludedTemplates.size()>0);
	}

}
