//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.2.4-2 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2015.06.09 at 11:11:31 AM CEST 
//


package net.ihe.gazelle.tempmodel.org.decor.art.model;

import javax.xml.bind.annotation.XmlEnum;
import javax.xml.bind.annotation.XmlEnumValue;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for DataSetValueType.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * <pre>
 * &lt;simpleType name="DataSetValueType"&gt;
 *   &lt;restriction base="{}EnumerationToken"&gt;
 *     &lt;enumeration value="count"/&gt;
 *     &lt;enumeration value="code"/&gt;
 *     &lt;enumeration value="ordinal"/&gt;
 *     &lt;enumeration value="identifier"/&gt;
 *     &lt;enumeration value="string"/&gt;
 *     &lt;enumeration value="text"/&gt;
 *     &lt;enumeration value="date"/&gt;
 *     &lt;enumeration value="datetime"/&gt;
 *     &lt;enumeration value="complex"/&gt;
 *     &lt;enumeration value="quantity"/&gt;
 *     &lt;enumeration value="duration"/&gt;
 *     &lt;enumeration value="boolean"/&gt;
 *     &lt;enumeration value="blob"/&gt;
 *     &lt;enumeration value="decimal"/&gt;
 *   &lt;/restriction&gt;
 * &lt;/simpleType&gt;
 * </pre>
 * 
 */
@XmlType(name = "DataSetValueType")
@XmlEnum
public enum DataSetValueType {


    /**
     * Countable (non-monetary) quantities. Used for countable types such as pregnancies, steps (taken by a physiotherapy patient), number of cigarettes
     *                         smoked in a day.
     * 
     */
    @XmlEnumValue("count")
    COUNT("count"),

    /**
     * A system of valid symbols that substitute for specified concepts e.g. alpha, numeric, symbols and/or combinations, usually defined by a formal
     *                         reference to a terminology or ontology, but may also be defined by the provision of text.
     * 
     */
    @XmlEnumValue("code")
    CODE("code"),

    /**
     * Models rankings and scores, e.g. pain, Apgar, reflex, ASA, Tanner values, etc, where there is a) implied ordering, b) no implication that the
     *                         distance between each value is con- stant, and c) the total number of values is finite. Note that although the term ‘ordinal’ in mathematics means natural numbers only, here
     *                         any integer is allowed, since negative and zero values are often used by medical professionals for values around a neutral point.
     * 
     */
    @XmlEnumValue("ordinal")
    ORDINAL("ordinal"),

    /**
     * Type for representing identifiers of real-world entities. Typical identifiers include drivers licence number, social security number,
     *                         prescription id, order id, and so on.
     * 
     */
    @XmlEnumValue("identifier")
    IDENTIFIER("identifier"),

    /**
     * Plain text without markup
     * 
     */
    @XmlEnumValue("string")
    STRING("string"),

    /**
     * A text item, which may contain any amount of legal characters arranged as e.g. words, sentences etc. Visual formatting and hyperlinks may be
     *                         included.
     * 
     */
    @XmlEnumValue("text")
    TEXT("text"),

    /**
     * Represents an absolute point in time, as measured on the Gregorian calendar, and specified only to the day. Semantics defined by ISO 8601. Used
     *                         for recording dates in real world time. The partial form is used for approximate birth dates, dates of death, etc.
     * 
     */
    @XmlEnumValue("date")
    DATE("date"),

    /**
     * Represents an absolute point in time, specified to the second. Semantics defined by ISO 8601. Used for recording a precise point in real world
     *                         time, e.g. the exact date and time of the birth of a baby, and for approximate time stamps, e.g. the origin of an history observation which is only partially
     *                         known.
     * 
     */
    @XmlEnumValue("datetime")
    DATETIME("datetime"),

    /**
     * collection of data, e.g. complex specification as part of dosage instructions, a person's name (if not further specified)
     * 
     */
    @XmlEnumValue("complex")
    COMPLEX("complex"),

    /**
     * Quantitified type representing "scientific" quantities, i.e. quantities expressed as a magnitude and units. For time durations duration shall be
     *                         used; for monetary amounts currency shall be used (not yet available, currently use 'quantity')
     * 
     */
    @XmlEnumValue("quantity")
    QUANTITY("quantity"),

    /**
     * Is a quantity, represents a period of time with respect to a notional point in time, which is not specified. A sign may be used to indicate the
     *                         duration is “backwards” in time rather than forwards.
     * 
     */
    @XmlEnumValue("duration")
    DURATION("duration"),

    /**
     * Items which are truly boolean data, such as true/false or yes/no answers.
     * 
     */
    @XmlEnumValue("boolean")
    BOOLEAN("boolean"),

    /**
     * Things that are typically stored as binary objects in the computer world and need to be rendered appropriately, e.g. images: like X-rays,
     *                         computertomographic images and scans.
     * 
     */
    @XmlEnumValue("blob")
    BLOB("blob"),

    /**
     * Decimal number (rarely used, in most cases a decimal number is actually a quantity).
     * 
     */
    @XmlEnumValue("decimal")
    DECIMAL("decimal");
    private final String value;

    DataSetValueType(String v) {
        value = v;
    }

    public String value() {
        return value;
    }

    public static DataSetValueType fromValue(String v) {
        for (DataSetValueType c: DataSetValueType.values()) {
            if (c.value.equals(v)) {
                return c;
            }
        }
        throw new IllegalArgumentException(v);
    }

}
